/*------------------------------------------------*/
/* UART֐                                       */
/*------------------------------------------------*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include "uart.h"

/* UART */

void uart_init (uint32_t baud)
{
	DDRD |= (1<<DDRD3);
	UBRR1H = (unsigned char)(baud >> 8);	/* ްڰĐݒ */
	UBRR1L = (unsigned char)baud;
	UCSR1B = (1<<RXEN1)|(1<<TXEN1);			/* M */
}

uint8_t uart_getc (void)
{
	while (!(UCSR1A & (1 << RXC1)));		/* Mްҋ@ */
	return UDR1;							/* ɏՕMް擾ĕԂ */
}

/* Mׂo */

void uart_putc (uint8_t data)
{
	while (!(UCSR1A & (1 << UDRE1)));		/* MɏՕҋ@ */
	UDR1 = data;							/* ɏՕްzuAްo */
}
