/**
 * \file
 *
 * \brief \pHaven Display UG 2832HSWEG04\ڍ
 *
 * 쌠 (c) 2013-2015 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *    (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *    ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
/*
 * xFAQ: <a href="http://www.atmel.com/design-support/">Atmelx</a>q˂ĂB
 */

#include "gfx_mono_ug_2832hsweg04.h"

/* ǂݖ߂ȂŒ̪gpꍇAڰъɏՕgpĂB */

#ifdef CONFIG_SSD1306_FRAMEBUFFER
static uint8_t framebuffer[GFX_MONO_LCD_FRAMEBUFFER_SIZE];
#endif

/**
 * \brief SSD1306LCD\
 * ܂ĄRAMɑS0܂B
 *
 * \note ̊֐͕\̓e܂B
 */
void gfx_mono_ssd1306_init(void)
{
	uint8_t page;
	uint8_t column;

#ifdef CONFIG_SSD1306_FRAMEBUFFER
	gfx_mono_set_framebuffer(framebuffer);
#endif

	ssd1306_init();								/* ʕ\퐧 */
	ssd1306_set_display_start_line_address(0);	/* s0ްo͂悤ɕ\ݒ */

	/* \̓e܂B
	 * ڰъɏՕ(SPI̪)gpꍇA؂ڰъɏՕ̗
	 * ܂B
	 */
	for (page = 0; page < GFX_MONO_LCD_PAGES; page++) {
		for (column = 0; column < GFX_MONO_LCD_WIDTH; column++) {
			gfx_mono_ssd1306_put_byte(page, column, 0x00, true);
		}
	}
}

#ifdef CONFIG_SSD1306_FRAMEBUFFER
/**
 * \brief ڰъɏՕLCDɏo
 *
 * ̊֐RAMڰъɏՕŜLCD֏o͂܂B
 *
 * \note ͸̨{vfgpꍇɎIɍs܂BȂ̺
 *		 ނڰъɏՕ𒼐ڑ삷ꍇɂKvłB
 */
void gfx_mono_ssd1306_put_framebuffer(void)
{
	uint8_t page;

	for (page = 0; page < GFX_MONO_LCD_PAGES; page++) {
		ssd1306_set_page_address(page);
		ssd1306_set_column_address(0);
		gfx_mono_ssd1306_put_page(framebuffer
				+ (page * GFX_MONO_LCD_WIDTH), page, 0,
				GFX_MONO_LCD_WIDTH);
	}
}
#endif

/**
 * \brief ߸قʂɕ`
 *
 * \param[in] x			߸قXW
 * \param[in] y			߸قYW
 * \param[in] color		߸ّ
 *
 * ȉx=10,y=10߸قݒ肵܂B
 * \code
	gfx_mono_ssd1306_draw_pixel(10, 10, GFX_PIXEL_SET);
\endcode
 * ȉx=10,y=10߸ق܂B
 * \code
	gfx_mono_ssd1306_draw_pixel(10, 10, GFX_PIXEL_CLR);
\endcode
 * Ĉȉx=10,y=10߸ق𔽓]\܂B
 * \code
	gfx_mono_ssd1306_draw_pixel(10, 10, GFX_PIXEL_XOR);
\endcode
 */
void gfx_mono_ssd1306_draw_pixel(gfx_coord_t x, gfx_coord_t y,
		gfx_coord_t color)
{
	uint8_t page;
	uint8_t pixel_mask;
	uint8_t pixel_value;

	/* ʊOɕ`悳߸قj */
	if ((x > GFX_MONO_LCD_WIDTH - 1) || (y > GFX_MONO_LCD_HEIGHT - 1)) {
		return;
	}

	page = y / GFX_MONO_LCD_PIXELS_PER_BYTE;
	pixel_mask = (1 << (y - (page * 8)));

	/*
	 * ֌W߸ق܂߰ނǂ݁Ǎɂ߰ނ\ɏ߂
	 * Oɂ߸قɗvꂽs܂B
	 */
	pixel_value = gfx_mono_get_byte(page, x);

	switch (color) {
	case GFX_PIXEL_SET:
		pixel_value |= pixel_mask;
		break;
	case GFX_PIXEL_CLR:
		pixel_value &= ~pixel_mask;
		break;
	case GFX_PIXEL_XOR:
		pixel_value ^= pixel_mask;
		break;
	default:
		break;
	}
	gfx_mono_put_byte(page, x, pixel_value);
}

/**
 * \brief x,y߸ْl擾
 *
 * \param[in] x		߸قXW
 * \param[in] y		߸قYW
 * \return			߸قݒȂA0l
 *
 * ȉ̗x=10,y=10߸ْlǂ݂܂B
 * \code
	pixelval = gfx_mono_ssd1306_get_pixel(10,10);
\endcode
 */
uint8_t gfx_mono_ssd1306_get_pixel(gfx_coord_t x, gfx_coord_t y)
{
	uint8_t page;
	uint8_t pixel_mask;

	if ((x > GFX_MONO_LCD_WIDTH - 1) || (y > GFX_MONO_LCD_HEIGHT - 1)) {
		return 0;
	}

	page = y / GFX_MONO_LCD_PIXELS_PER_BYTE;
	pixel_mask = (1 << (y - (page * 8)));

	return gfx_mono_get_byte(page, x) & pixel_mask;
}

/**
 * \brief RAM\߰ނo
 *
 * 킪SPI̪ɂıꍇALCDRAMްǂݖ߂
 * Ƃł܂B̂߁A̓`ԂLCD֏ꂽSĂްMCU
 * RAMڰъɏՕɂ܂B
 *
 * \param[in] data		ׂްւ̈ʒuwq
 * \param[in] page		߰ ڽ
 * \param[in] column	߰ޓ̕ψ(xW)
 * \param[in] width		޲Đ
 *
 * ȉ̗data_buf߰01032޲Ă܂Bx1=10,y1=0,x2=42,
 * y2=8(ʍォ10߸)̋`data_bufɒu܂B
 * \code
	gfx_mono_ssd1306_put_page(data_buf, 0, 10, 32);
\endcode
 */
void gfx_mono_ssd1306_put_page(gfx_mono_color_t *data, gfx_coord_t page,
		gfx_coord_t column, gfx_coord_t width)
{
#ifdef CONFIG_SSD1306_FRAMEBUFFER
	gfx_mono_framebuffer_put_page(data, page, column, width);
#endif
	ssd1306_set_page_address(page);
	ssd1306_set_column_address(column);

	do {
		ssd1306_write_data(*data++);
	} while (--width);
}

/**
 * \brief LCD킩߰ނǂ݂܂B
 *
 * LCD킪SPI̪ɂıꍇA킩璼ްǂނƂ
 * ł܂B̏ꍇAɋǏڰъɏՕްǂ݂܂B
 *
 * \param[in] data		ǂްi[ꏊւ̈ʒuwq
 * \param[in] page		߰ ڽ
 * \param[in] column	߰ޓ̕ψ(xW)
 * \param[in] width		ǂ޲Đ
 *
 * ȉ̗͕\؂ŏ128޲(擪߰)ǂݖ߂܂B
 * \code
	gfx_mono_ssd1306_get_page(read_buffer, 0, 0, 128);
\endcode
 */
void gfx_mono_ssd1306_get_page(gfx_mono_color_t *data, gfx_coord_t page,
		gfx_coord_t column, gfx_coord_t width)
{
#ifdef CONFIG_SSD1306_FRAMEBUFFER
	gfx_mono_framebuffer_get_page(data, page, column, width);
#else
	ssd1306_set_page_address(page);
	ssd1306_set_column_address(column);

	do {
		*data++ = ssd1306_read_data();
	} while (--width);
#endif
}

/**
 * \brief \RAM޲Ăo
 *
 * LCD킪SPI̪ɂıꍇAްǏڰъɏՕɂu
 * ܂B
 *
 * \param[in] page		߰ ڽ
 * \param[in] column	߰ޕψ(xW)
 * \param[in] data		ׂް
 * \param[in] force		݋
 *
 * ̗͕\ؓ̐擪޲Ă0xFF̒lo͂܂B͕\̍
 * 8߸ق̗ݒ肵܂B
 * \code
	gfx_mono_ssd1306_put_byte(0, 0, 0xFF, false);
\endcode
  */
 void gfx_mono_ssd1306_put_byte(gfx_coord_t page, gfx_coord_t column,
		uint8_t data, bool force)
{
#ifdef CONFIG_SSD1306_FRAMEBUFFER
	if (!force && data == gfx_mono_framebuffer_get_byte(page, column)) {
		return;
	}
	gfx_mono_framebuffer_put_byte(page, column, data);
#endif

	ssd1306_set_page_address(page);
	ssd1306_set_column_address(column);

	ssd1306_write_data(data);
}

/**
 * \brief \RAM޲Ă擾
 *
 * LCD킪SPI̪籸ꍇAްǂނƂł܂B̏
 * AɋǏڰъɏՕްԂ܂B
 *
 * \param[in] page		߰ ڽ
 * \param[in] column	߰ޕψ(xW)
 * \return				LCD܂ڰъɏՕް
 *
 * ȉ̺ނ͕\؂܂͒ړǂݍ݂s\ȏꍇ͋ǏڰъɏՕ
 * 擪޲ēǂ݂܂Bްx=0,y=0`y=7߸ق\܂B
 * \code
	data = gfx_mono_ssd1306_get_byte(0, 0);
\endcode
 */
uint8_t gfx_mono_ssd1306_get_byte(gfx_coord_t page, gfx_coord_t column)
{
#ifdef CONFIG_SSD1306_FRAMEBUFFER
	return gfx_mono_framebuffer_get_byte(page, column);
#else
	ssd1306_set_page_address(page);
	ssd1306_set_column_address(column);
	return ssd1306_read_data();
#endif
}

/**
 * \brief \޲ĂǂŕύXď܂B
 *
 * ̊֐͕\(܂͐킩璼ړǂ߂ȂꍇڰъɏՕ)޲Ă
 * ǂ݁A񋟂ꂽcolorpixel_maskɂđI΂ꂽ߸ّɏ]޲Ă
 * Օs܂B
 *
 * \param[in] page			߰ ڽ
 * \param[in] column		߰ޕψ(xW)
 * \param[in] pixel_mask	߸ّpՕ
 * \param[in] color			߸ّ
 *
 * \؂̐擪޲Ă0XAAƂXOR鏬ȗ
 * \code
	gfx_mono_ssd1306_mask_byte(0,0,0xAA,GFX_PIXEL_XOR);
\endcode
 */
void gfx_mono_ssd1306_mask_byte(gfx_coord_t page, gfx_coord_t column,
		gfx_mono_color_t pixel_mask, gfx_mono_color_t color)
{
	gfx_mono_color_t temp = gfx_mono_get_byte(page, column);

	switch (color) {
	case GFX_PIXEL_SET:
		temp |= pixel_mask;
		break;
	case GFX_PIXEL_CLR:
		temp &= ~pixel_mask;
		break;
	case GFX_PIXEL_XOR:
		temp ^= pixel_mask;
		break;
	default:
		break;
	}
	gfx_mono_put_byte(page, column, temp);
}
