/**
 * \file
 *
 * \brief ̫Ăƕ`ٰ
 *
 * 쌠 (c) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *    (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *    ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "stddef.h"
#include "assert.h"
#ifdef CONFIG_HUGEMEM
# include "hugemem.h"
#endif
#include "progmem.h"

#include "gfx_mono.h"
#include "gfx_mono_text.h"

#ifndef CONFIG_FONT_PIXELS_PER_BYTE
# define CONFIG_FONT_PIXELS_PER_BYTE	8
#endif

#define EXTMEM_BUF_SIZE					20

#if defined(CONFIG_HUGEMEM) || defined(__DOXYGEN__)

/**
 * \internal
 * \brief hugemem̫Ă\֕`悷菕֐
 *
 * ̊֐͓蕶ްɓnČJԂ̂ɐ旧čŏ̫ĕް̊Jn
 * ψʂvZ܂B
 *
 * ׂ߸ق̂悤ɍsAĂяo͕
 * \Oɕ`̈邱ƂKvƂ܂Bgfx_mono_draw_strin
 * g()gfx_mono_draw_progmem_string()̊֐ɂčs܂B
 *
 * \param ch		`悳ׂ
 * \param x			ʏXW
 * \param y			ʏYW
 * \param font		`悷̫
 */
static void gfx_mono_draw_char_hugemem(const char ch, const gfx_coord_t x,
		const gfx_coord_t y, const struct font *font)
{
	uint8_t i;
	uint8_t char_row_size;
	uint8_t glyph_size;
	uint16_t glyph_data_offset;
	uint8_t char_buff[EXTMEM_BUF_SIZE];
	uint8_t buffer_pos;
	uint8_t rows_left;

	gfx_coord_t inc_x = x;
	gfx_coord_t inc_y = y;

	char_row_size = font->width / CONFIG_FONT_PIXELS_PER_BYTE;
	if (font->width % CONFIG_FONT_PIXELS_PER_BYTE) {
		char_row_size++;
	}

	glyph_size = char_row_size * font->height;
	glyph_data_offset = glyph_size * ((uint8_t)ch - font->first_char);
	buffer_pos = EXTMEM_BUF_SIZE;
	rows_left = font->height;

	do {
		static uint8_t glyph_byte = 0;
		uint8_t pixelsToDraw = font->width;

		for (i = 0; i < pixelsToDraw; i++) {
			if (i % CONFIG_FONT_PIXELS_PER_BYTE == 0) {
				/* Read another byte from hugemem */
				if (buffer_pos >= EXTMEM_BUF_SIZE) {
					hugemem_ptr_t source
						= font->data.hugemem;
					source = (hugemem_ptr_t)
							((uint32_t)source +
							glyph_data_offset);

					hugemem_read_block(char_buff, source,
							EXTMEM_BUF_SIZE);

					glyph_data_offset += EXTMEM_BUF_SIZE;
					buffer_pos = 0;
				}

				glyph_byte = char_buff[buffer_pos];
				buffer_pos++;
			}

			/* ̂ޯĂʂɕ` */
			if ((glyph_byte & 0x80)) {
				gfx_mono_draw_pixel(inc_x, inc_y,
						GFX_PIXEL_SET);
			}

			inc_x += 1;
			glyph_byte <<= 1;
		}

		inc_y += 1;
		inc_x = x;
	} while (--rows_left > 0);
}
#endif

/**
 * \internal
 * \brief progmem̫Ă\֕`悷菕֐
 *
 * ̊֐͓蕶ްɓnČJԂ̂ɐ旧čŏ̫ĕް̊Jn
 * ψʂvZ܂B
 *
 * ׂ߸ق̂悤ɍsAĂяo͕
 * \Oɕ`̈邱ƂKvƂ܂Bgfx_mono_draw_strin
 * g()gfx_mono_draw_progmem_string()̊֐ɂčs܂B
 *
 * \param ch		`悳ׂ
 * \param x			ʏXW
 * \param y			ʏYW
 * \param font		`悷̫
 */
static void gfx_mono_draw_char_progmem(const char ch, const gfx_coord_t x,
		const gfx_coord_t y, const struct font *font)
{
	uint8_t PROGMEM_PTR_T glyph_data;
	uint16_t glyph_data_offset;
	uint8_t char_row_size;
	uint8_t rows_left;
	uint8_t i;

	gfx_coord_t inc_x = x;
	gfx_coord_t inc_y = y;

	char_row_size = font->width / CONFIG_FONT_PIXELS_PER_BYTE;
	if (font->width % CONFIG_FONT_PIXELS_PER_BYTE) {
		char_row_size++;
	}

	glyph_data_offset = char_row_size * font->height *
			((uint8_t)ch - font->first_char);
	glyph_data = font->data.progmem + glyph_data_offset;
	rows_left = font->height;

	do {
		uint8_t glyph_byte = 0;
		uint8_t pixelsToDraw = font->width;

		for (i = 0; i < pixelsToDraw; i++) {
			if (i % CONFIG_FONT_PIXELS_PER_BYTE == 0) {
				glyph_byte = PROGMEM_READ_BYTE(glyph_data);
				glyph_data++;
			}

			if ((glyph_byte & 0x80)) {
				gfx_mono_draw_pixel(inc_x, inc_y,
						GFX_PIXEL_SET);
			}

			inc_x += 1;
			glyph_byte <<= 1;
		}

		inc_y += 1;
		inc_x = x;
		rows_left--;
	} while (rows_left > 0);
}

/**
 * \brief \ɕ`
 *
 * \param ch		`悳ׂ
 * \param x			ʏXW
 * \param y			ʏYW
 * \param font		`悷̫
 */
void gfx_mono_draw_char(const char c, const gfx_coord_t x, const gfx_coord_t y,
		const struct font *font)
{
	gfx_mono_draw_filled_rect(x, y, font->width, font->height,
			GFX_PIXEL_CLR);

	switch (font->type) {
	case FONT_LOC_PROGMEM:
		gfx_mono_draw_char_progmem(c, x, y, font);
		break;
#ifdef CONFIG_HUGEMEM
	case FONT_LOC_HUGEMEM:
		gfx_mono_draw_char_hugemem(c, x, y, font);
		break;
#endif
	default:
		/* Unsupported mode, call assert */
		break;
	}
}

/**
 * \brief \ɕ`
 *
 * ̊֐ؓɒuꂽ\ɕ`悵܂B
 *
 * \param str		ւ̈ʒuwq
 * \param x			ʏXW
 * \param y			ʏYW
 * \param font		`悷̫
 */
void gfx_mono_draw_string(const char *str, gfx_coord_t x, gfx_coord_t y,
		const struct font *font)
{
	const gfx_coord_t start_of_string_position_x = x;	/* CRŖ߂ꏊm邽߂Xۑ */

	do {										/*  ޲Ă܂Ŋe` */
		/* VKsƂ'\n'AW` */
		if (*str == '\n') {
			x = start_of_string_position_x;
			y += font->height + 1;
		} else if (*str == '\r') {
			/* '\r'΂ */
		} else {
			gfx_mono_draw_char(*str, x, y, font);
			x += font->width;
		}
	} while (*(++str));
}

/**
 * \brief ۸ ؂ɒuꂽ\ɕ`
 *
 * ̊֐۸ ؂ɒuꂽ\ɕ`悵ARAM̕ް
 * ۸ ؂萔ްgp邱Ƃgfx_mono_draw_string()ƈ
 * ܂B
 *
 * 萔۸ ؂gp邱ƂRAMɑ΂鉞̗v炵ÂɑŜ
 * Lʂ܂B
 *
 * \param str		۸ ؂ɒuꂽւ̈ʒuwq
 * \param x			ʏXW
 * \param y			ʏYW
 * \param font		`悷̫
 */
void gfx_mono_draw_progmem_string(char PROGMEM_PTR_T str, gfx_coord_t x,
		gfx_coord_t y, const struct font *font)
{
	char temp_char;

	const gfx_coord_t start_of_string_position_x = x;	/* CRŖ߂ꏊm邽߂Xۑ */

	/*  ޲Ă܂Ŋe` */
	temp_char = PROGMEM_READ_BYTE((uint8_t PROGMEM_PTR_T)str);

	while (temp_char) {
		/* VKsƂ'\n'AW` */
		if (temp_char == '\n') {
			x = start_of_string_position_x;
			y += font->height + 1;
		} else if (temp_char == '\r') {
			/* '\r'΂ */
		} else {
			gfx_mono_draw_char(temp_char, x, y, font);
			x += font->width;
		}

		temp_char = PROGMEM_READ_BYTE((uint8_t PROGMEM_PTR_T)(++str));
	}
}

/**
 * \brief ̋EgvZ
 *
 * \note ̏ꍇɕԂl1߸قō̫Ă̍ƓȂ܂B
 *
 * \param str		EgvZ镶
 * \param font		gp̫
 * \param width		̌ʂւ̈ʒuwq
 * \param height	̌ʂւ̈ʒuwq
 */
void gfx_mono_get_string_bounding_box(const char *str, const struct font *font,
		gfx_coord_t *width, gfx_coord_t *height)
{
	gfx_coord_t font_width = font->width;
	gfx_coord_t font_height = font->height;

	gfx_coord_t max_width = 1;
	gfx_coord_t max_height = font_height;
	gfx_coord_t x = 0;

	/*  ޲Ă܂Ŋe` */
	do {
		/* VKsƂ'\n'AW` */
		if (*str == '\n') {
			x = 0;
			max_height += font_height;
		} else if (*str == '\r') {
			/* '\r'΂ */
		} else {
			x += font_width;
			if (x > max_width) {
				max_width = x;
			}
		}
	} while (*(++str));

	/* QƂʂĒlԂ܂B */
	*width = max_width;
	*height = max_height;
}

/**
 * \brief ۸ ؂ɒuꂽ̋EgvZ
 *
 * \note ̏ꍇɕԂl1߸قō̫Ă̍ƓȂ܂B
 *
 * \param str		EgvZ۸ ؓ̕
 * \param font		gp̫
 * \param width		̌ʂւ̈ʒuwq
 * \param height	̌ʂւ̈ʒuwq
 */
void gfx_mono_get_progmem_string_bounding_box(char PROGMEM_PTR_T str,
		const struct font *font, gfx_coord_t *width,
		gfx_coord_t *height)
{
	gfx_coord_t font_width = font->width;
	gfx_coord_t font_height = font->height;

	char temp_char;
	gfx_coord_t max_width = 1;
	gfx_coord_t max_height = font_height;
	gfx_coord_t x = 0;

	/*  ޲Ă܂Ŋe` */
	temp_char = PROGMEM_READ_BYTE((uint8_t PROGMEM_PTR_T)str);

	while (temp_char) {
		/* VKsƂ'\n'AW` */
		if (temp_char == '\n') {
			x = 0;
			max_height += font_height;
		} else if (*str == '\r') {
			/* '\r'΂ */
		} else {
			x += font_width;
			if (x > max_width) {
				max_width = x;
			}
		}

		temp_char = PROGMEM_READ_BYTE((uint8_t PROGMEM_PTR_T)(++str));
	}

	/* QƂʂĒlԂ܂B */
	*width = max_width;
	*height = max_height;
}
