/**
 * \file
 *
 * \brief SSD1306 OLED\ײ
 *
 * 쌠 (c) 2012-2015 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *    (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *    ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
/*
 * xFAQ: <a href="http://www.atmel.com/design-support/">Atmelx</a>q˂ĂB
 */

#include "ssd1306.h"

/**
 * \internal
 * \brief ʰ޳ ̪
 *
 * OLED̪̂Ɏgp̪ɈˑāÅ֐͕Kvʰ޳
 * ܂B
 */
static void ssd1306_interface_init(void)
{
	DDRB |= SSD1306_CS_PIN | SSD1306_MOSI_PIN| SSD1306_SCK_PIN;
	DDRD |= SSD1306_RES_PIN;
	DDRA |= SSD1306_DC_PIN;

	SPCR0 = (1 << SPE0) | (1 << MSTR0);
}

/**
 * \brief OLED평
 *
 * ʰ޳ ̪OLEDɂ͂̊֐ĂłBs
 * ƁA\ONɐ؂ւް󂯎鏀܂B
 */
void ssd1306_init(void)
{
	ssd1306_hard_reset();					// OLED\ʰ޳ ؾĂs܂B
	ssd1306_interface_init();				// ̪
	PORTD |=  SSD1306_RES_PIN;				// ؾ ݂Ԃɐݒ

	ssd1306_write_command(SSD1306_CMD_SET_MULTIPLEX_RATIO);	// 1/32ޭè(0x0F`0x3F)
	ssd1306_write_command(0x1F);
	ssd1306_write_command(SSD1306_CMD_SET_DISPLAY_OFFSET);	// 蓖RAMvړ(0x00`0x3F)
	ssd1306_write_command(0x00);
	ssd1306_write_command(SSD1306_CMD_SET_DISPLAY_START_LINE(0x00));	// 蓖RAM\Jnsݒ(0x00`0x3F)
	ssd1306_write_command(SSD1306_CMD_SET_SEGMENT_RE_MAP_COL127_SEG0);		// SEG0Ɋ蓖Ăꂽڽ0ݒ
	ssd1306_write_command(SSD1306_CMD_SET_COM_OUTPUT_SCAN_DOWN);	// COM/RowCOM63`0ɐݒ
	ssd1306_write_command(SSD1306_CMD_SET_COM_PINS);	// COM ʰ޳`Ԑݒ
	ssd1306_write_command(0x02);

	ssd1306_set_contrast(0x8F);

	ssd1306_write_command(SSD1306_CMD_ENTIRE_DISPLAY_AND_GDDRAM_ON);	// S̕\ON֎~
	ssd1306_display_invert_disable();
	ssd1306_write_command(SSD1306_CMD_SET_DISPLAY_CLOCK_DIVIDE_RATIO);	// \ۯ/Ugݒ(=0x80)
	ssd1306_write_command(0x80);
	ssd1306_write_command(SSD1306_CMD_SET_CHARGE_PUMP_SETTING);	//  ߒ틖
	ssd1306_write_command(0x14);
	ssd1306_write_command(SSD1306_CMD_SET_VCOMH_DESELECT_LEVEL);	// VCOMHؒfِݒ
	ssd1306_write_command(0x40);									// =0x20(0.77~VCC)
	ssd1306_write_command(SSD1306_CMD_SET_PRE_CHARGE_PERIOD);	// O[d15ۯAd1ۯƂĐݒ
	ssd1306_write_command(0xF1);

	ssd1306_display_on();
}

/**
 * \brief \ɖߏ
 *
 * ̊֐͐ɏOD/C#LowɈ܂BI̪ɊÂĈ
 * Ȃް݊֐Ă΂܂B
 *
 * \param command	閽
 */
void ssd1306_write_command(uint8_t command)
{
	PORTB &= ~SSD1306_CS_PIN;
	PORTA &= ~SSD1306_DC_PIN;
	SPDR0  = command;
	while(!(SPSR0 & (1<<SPIF0)));
	PORTB |= SSD1306_CS_PIN;
}

/**
 * \brief \ް
 *
 * ̊֐͐ɏOD/C#ݒ(High)܂BI̪ɊÂ
 * قȂް݊֐Ă΂܂B
 *
 * \param data		ް
 */
void ssd1306_write_data(uint8_t data)
{
	PORTB &= ~SSD1306_CS_PIN;
	PORTA |= SSD1306_DC_PIN;
	SPDR0  = data;
	while(!(SPSR0 & (1<<SPIF0)));
	PORTB |= SSD1306_CS_PIN;
}
